<?php
// +-----------------------------------------------------------------+
// |                   PhreeBooks Open Source ERP                    |
// +-----------------------------------------------------------------+
// | Copyright (c) 2008, 2009, 2010 PhreeSoft, LLC                   |
// | http://www.PhreeSoft.com                                        |
// +-----------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or   |
// | modify it under the terms of the GNU General Public License as  |
// | published by the Free Software Foundation, either version 3 of  |
// | the License, or any later version.                              |
// |                                                                 |
// | This program is distributed in the hope that it will be useful, |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
// | GNU General Public License for more details.                    |
// |                                                                 |
// | The license that is bundled with this package is located in the |
// | file: /doc/manual/ch01-Introduction/license.html.               |
// | If not, see http://www.gnu.org/licenses/                        |
// +-----------------------------------------------------------------+
//  Path: /modules/inventory/defaults.php
//

define('MAX_INVENTORY_SKU_LENGTH', 24); // database is currently set for a maximum of 24 characters
define('MAX_NUM_PRICE_LEVELS', 5);
define('DEFAULT_TEXT_LENGTH', '32');
define('DEFAULT_REAL_DISPLAY_FORMAT', '10,2');
define('DEFAULT_INPUT_FIELD_LENGTH', 120);

// the inventory type indexes should not be changed or the inventory module won't work.
// system generated types (not to be displayed are: ai - assembly item, mi - master stock with attributes)
$inventory_types = array(
  'si' => INV_TYPES_SI,
  'sr' => INV_TYPES_SR,
  'ms' => INV_TYPES_MS,
  'as' => INV_TYPES_AS,
  'sa' => INV_TYPES_SA,
  'ns' => INV_TYPES_NS,
  'lb' => INV_TYPES_LB,
  'sv' => INV_TYPES_SV,
  'sf' => INV_TYPES_SF,
  'ci' => INV_TYPES_CI,
  'ai' => INV_TYPES_AI,
  'ds' => INV_TYPES_DS,
);

// used for identifying inventory types in reports and forms that are not selectable by the user
$inventory_types_plus       = $inventory_types;
$inventory_types_plus['ia'] = INV_TYPES_IA;
$inventory_types_plus['mi'] = INV_TYPES_MI;

$cost_methods = array(
  'f' => INV_TEXT_FIFO,	   // First-in, First-out
  'l' => INV_TEXT_LIFO,	   // Last-in, First-out
  'a' => INV_TEXT_AVERAGE, // Average Costing
); 

$integer_lengths = array(
  '0' => '-127 '           . TEXT_TO . ' 127',
  '1' => '-32,768 '        . TEXT_TO . ' 32,768',
  '2' => '-8,388,608 '     . TEXT_TO . ' 8,388,607',
  '3' => '-2,147,483,648 ' . TEXT_TO . ' 2,147,483,647',
  '4' => INV_TEXT_GREATER_THAN . ' 2,147,483,648',
);

$decimal_lengths = array(
  '0' => TEXT_SGL_PREC,
  '1' => TEXT_DBL_PREC,
);

$check_box_choices = array(
  '0' => TEXT_UNCHECKED, 
  '1' => TEXT_CHECKED,
);

$price_mgr_sources = array(
  '0' => TEXT_NOT_USED,	// Do not remove this selection, leave as first entry
  '1' => TEXT_DIR_ENTRY,
  '2' => TEXT_ITEM_COST,
  '3' => TEXT_RETAIL_PRICE,
// Price Level 1 needs to always be at the end (it is pulled from the first row to avoid a circular reference)
// The index can change but must be matched with the javascript to update the price source values.
  '4' => TEXT_PRICE_LVL_1,
);	

$price_mgr_adjustments = array(
  '0' => TEXT_NONE,
  '1' => TEXT_DEC_AMT,
  '2' => TEXT_DEC_PCNT,
  '3' => TEXT_INC_AMT,
  '4' => TEXT_INC_PCNT,
);

$price_mgr_rounding = array(
  '0' => TEXT_NONE,
  '1' => TEXT_NEXT_WHOLE,
  '2' => TEXT_NEXT_FRACTION,
  '3' => TEXT_NEXT_INCREMENT,
);

?>