<?php 
// +-----------------------------------------------------------------+
// |                   PhreeBooks Open Source ERP                    |
// +-----------------------------------------------------------------+
// | Copyright (c) 2008, 2009, 2010 PhreeSoft, LLC                   |
// | http://www.PhreeSoft.com                                        |
// +-----------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or   |
// | modify it under the terms of the GNU General Public License as  |
// | published by the Free Software Foundation, either version 3 of  |
// | the License, or any later version.                              |
// |                                                                 |
// | This program is distributed in the hope that it will be useful, |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
// | GNU General Public License for more details.                    |
// |                                                                 |
// | The license that is bundled with this package is located in the |
// | file: /doc/manual/ch01-Introduction/license.html.               |
// | If not, see http://www.gnu.org/licenses/                        |
// +-----------------------------------------------------------------+
//  Path: /modules/payment/functions/payment.php
//

function load_service_modules() {
  $methods = array();
  if ($files = @scandir(DIR_FS_MODULES . 'payment/methods/')) {
    foreach ($files as $entry) {
	  if (defined('MODULE_PAYMENT_' . strtoupper($entry) . '_STATUS')) $methods[] = $entry;
    }
  }
  if (sizeof($methods) > 0) {
    sort($methods);
    foreach ($methods as $method) {
	  load_method_language(DIR_FS_MODULES . 'payment/methods/', $method);
	  include_once(DIR_FS_MODULES . 'payment/methods/' . $method . '/' . $method . '.php');
	}
  }
  return $methods;
}

function load_service_module($method) {
  load_method_language(DIR_FS_MODULES . 'payment/methods/', $method);
  include_once(DIR_FS_MODULES . 'payment/methods/' . $method . '/' . $method . '.php');
  return $method;
}

?>