<?php
// +-----------------------------------------------------------------+
// |                   PhreeBooks Open Source ERP                    |
// +-----------------------------------------------------------------+
// | Copyright (c) 2008, 2009, 2010 PhreeSoft, LLC                   |
// | http://www.PhreeSoft.com                                        |
// +-----------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or   |
// | modify it under the terms of the GNU General Public License as  |
// | published by the Free Software Foundation, either version 3 of  |
// | the License, or any later version.                              |
// |                                                                 |
// | This program is distributed in the hope that it will be useful, |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
// | GNU General Public License for more details.                    |
// |                                                                 |
// | The license that is bundled with this package is located in the |
// | file: /doc/manual/ch01-Introduction/license.html.               |
// | If not, see http://www.gnu.org/licenses/                        |
// +-----------------------------------------------------------------+
//  Path: /modules/phreeform/ajax/box_load.php
//

// This script builds the properties box for the form data type

$fID = $_GET['fID'] ? $_GET['fID'] : 'boxLoad';

/**************   Check user security   *****************************/
$xml = NULL;
$security_level = $_SESSION['admin_security'][SECURITY_ID_PHREEFORM];
if ($security_level == 0) { // no permission to enter page, return error
  echo createXmlHeader($fID) . xmlEntry('error', ERROR_NO_PERMISSION) . createXmlFooter();
  die;
}

/**************  include page specific files    *********************/
gen_pull_language($module);
require_once(DIR_FS_MODULES . 'phreeform/defaults.php');
require_once(DIR_FS_MODULES . 'phreeform/functions/phreeform.php');
require_once(DIR_FS_MODULES . 'phreeform/pages/popup_build/box_html.php');

/**************   page specific initialization  *************************/
$rID  = $_GET['rID'];
$type = $_GET['type'] ? $_GET['type'] : '';
if (!isset($_GET['rID'])) {
  echo createXmlHeader($fID) . xmlEntry('error', 'Row ID was not passed!') . createXmlFooter();
  die;
}

$kFonts       = gen_build_pull_down($Fonts);
$kFontSizes   = gen_build_pull_down($FontSizes);
$kLineSizes   = gen_build_pull_down($LineSizes);
$kFontColors  = gen_build_pull_down($FontColors);
$kFontAlign   = gen_build_pull_down($FontAlign);
$cFields      = CreateCompanyArray();
$fFields      = crit_build_pull_down($CritChoices);
$kFields      = CreateSpecialDropDown($report);
$kTables      = CreateTableList($report);
$nyChoice     = gen_build_pull_down($NoYesChoice);
$pFields      = gen_build_pull_down($FormProcessing);
$tProcessing  = gen_build_pull_down($TextProcessing);

if (!$type) { // use the first type of the FormEntries array since it will be shown first with a new line
  $temp = array_keys($FormEntries);
  $type = array_shift($temp);
}

$properties   = new objectInfo();
$properties->type = $type;
$output       = box_build($properties, $rID);

//put it all together
echo createXmlHeader($fID);
echo xmlEntry("rID",  $rID);
echo xmlEntry("html", $output);
echo xmlEntry("message", 'Success type = ' . $type . ' and html length = ' . strlen($output));
echo createXmlFooter();
die;
?>