<?php
// +-----------------------------------------------------------------+
// |                   PhreeBooks Open Source ERP                    |
// +-----------------------------------------------------------------+
// | Copyright (c) 2008, 2009, 2010 PhreeSoft, LLC                   |
// | http://www.PhreeSoft.com                                        |
// +-----------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or   |
// | modify it under the terms of the GNU General Public License as  |
// | published by the Free Software Foundation, either version 3 of  |
// | the License, or any later version.                              |
// |                                                                 |
// | This program is distributed in the hope that it will be useful, |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
// | GNU General Public License for more details.                    |
// |                                                                 |
// | The license that is bundled with this package is located in the |
// | file: /doc/manual/ch01-Introduction/license.html.               |
// | If not, see http://www.gnu.org/licenses/                        |
// +-----------------------------------------------------------------+
//  Path: /modules/phreeform/ajax/field_load.php
//

// This script builds the properties box for the form data type

$fID = $_GET['fID'] ? $_GET['fID'] : 'fieldLoad';

/**************   Check user security   *****************************/
$xml = NULL;
$security_level = $_SESSION['admin_security'][SECURITY_ID_PHREEFORM];
if ($security_level == 0) { // no permission to enter page, return error
  echo createXmlHeader($fID) . xmlEntry('error', ERROR_NO_PERMISSION) . createXmlFooter();
  die;
}

/**************  include page specific files    *********************/
gen_pull_language($module);
require_once(DIR_FS_MODULES . 'phreeform/functions/phreeform.php');

/**************   page specific initialization  *************************/
$report         = new objectInfo();
$report->tables = array();
$i              = 1;
$runaway        = 0; // just in case
while(true) {
  if (isset($_GET['t' . $i])) $report->tables[] = new objectInfo(array('tablename' => $_GET['t' . $i]));
    else break;
  $i++;
  if ($runaway++ > 100) die;
}
if (sizeof($report->tables) < 1) {
  echo createXmlHeader($fID) . xmlEntry('error', PHREEFORM_NO_TABLES_PASSED) . createXmlFooter();
  die;
}
$report->special_class = $_GET['sp'] ? $_GET['sp'] : false;

$kFields = CreateSpecialDropDown($report);
if (sizeof($kFields) > 0) foreach ($kFields as $value) {
  $xml .= "<option>\n";
  $xml .= "\t" . xmlEntry('id',   $value['id']);
  $xml .= "\t" . xmlEntry('text', $value['text']);
  $xml .= "</option>\n";
}

//put it all together
echo createXmlHeader($fID);
echo $xml;
echo xmlEntry("message", 'Success select length = ' . sizeof($kFields));
echo createXmlFooter();
die;
?>