<?php
// +-----------------------------------------------------------------+
// |                   PhreeBooks Open Source ERP                    |
// +-----------------------------------------------------------------+
// | Copyright (c) 2008, 2009, 2010 PhreeSoft, LLC                   |
// | http://www.PhreeSoft.com                                        |
// +-----------------------------------------------------------------+
// | This program is free software: you can redistribute it and/or   |
// | modify it under the terms of the GNU General Public License as  |
// | published by the Free Software Foundation, either version 3 of  |
// | the License, or any later version.                              |
// |                                                                 |
// | This program is distributed in the hope that it will be useful, |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of  |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   |
// | GNU General Public License for more details.                    |
// |                                                                 |
// | The license that is bundled with this package is located in the |
// | file: /doc/manual/ch01-Introduction/license.html.               |
// | If not, see http://www.gnu.org/licenses/                        |
// +-----------------------------------------------------------------+
//  Path: /modules/phreeform/pages/popup_build/template_import.php
//

// start the form
echo html_form('popup_build', FILENAME_DEFAULT, gen_get_all_get_params(array('action')), 'post', 'enctype="multipart/form-data"') . chr(10);

// include hidden fields
echo html_hidden_field('todo',        '') . chr(10);
echo html_hidden_field('id',          $id) . chr(10);
echo html_hidden_field('parent_id',   $parent_id) . chr(10);
echo html_hidden_field('doc_title',   '') . chr(10); // placeholder
echo html_hidden_field('folder_path', '/');

// customize the toolbar actions
$toolbar->icon_list['cancel']['params'] = 'onclick="self.close();"';
$toolbar->icon_list['open']['show']     = false;
$toolbar->icon_list['save']['show']     = false;
$toolbar->icon_list['print']['show']    = false;
$toolbar->icon_list['delete']['show']   = false;
$toolbar->icon_list['import_one'] = array(
  'show'   => true, 
  'icon'   => 'actions/media-playback-start.png',
  'params' => 'onclick="submitToDo(\'import_one\')"',
  'text'   => TEXT_IMPORT_ONE,
  'order'  => '10',
);
$toolbar->icon_list['save_all'] = array(
  'show'   => true, 
  'icon'   => 'actions/media-seek-forward.png',
  'params' => 'onclick="submitToDo(\'import_all\')"',
  'text'   => TEXT_IMPORT_ALL,
  'order'  => '15',
);
$toolbar->add_help('11.01.01');
echo $toolbar->build_toolbar(); 

// Build the page
?>
<h2 align="center"><?php echo PAGE_TITLE; ?></h2>
  <table align="center" border="0" cellspacing="1" cellpadding="1">
    <tr>
      <th colspan="2" align="center">
	    <?php echo TEXT_CURRENT_DIR_PATH . $import_path; ?>
	  </th>
    </tr>
    <tr>
      <td>
	    <?php echo TEXT_ENTER_NEW_PATH; ?>
		<?php echo html_input_field('import_path', $import_path, 'size="50"'); ?>
		<?php echo html_button_field('refresh_dir', TEXT_SEARCH_DIR, 'onclick="submitToDo(\'refresh_dir\')"'); ?>
	  </td>
    </tr>
	<tr>
      <th><?php echo PHREEFORM_DEFIMP; ?></th>
    </tr>
    <tr>
      <td><?php echo ReadDefReports('RptFileName', $import_path); ?></td>
    </tr>
    <tr>
      <td>
	    <?php echo PHREEFORM_RPTBROWSE . html_file_field('reportfile'); ?>
	  </td>
    </tr>
    <tr>
      <td>
	    <?php echo PHREEFORM_RPTENTER . '<br />' . PHREEFORM_RPTNOENTER; ?>
	    <?php echo html_input_field('reportname', $reportname, 'size="32" maxlength="30"'); ?>
	  </td>
    </tr>
  </table>
</form>
